#include <iostream>
#include <cstring>
#include <cstdio>
#include <cstdlib>
#include <cmath>
using namespace std;
struct pupil
{
	int classNum;
	char classLetter;
	char name[50];
	char surname[50];
	char birthDate[50];
};
pupil makeClass(char classFull[10], pupil currentPupil)
{
	int len=strlen(classFull);
	currentPupil.classLetter=classFull[len-1];
	classFull[len-1]='\0';
	currentPupil.classNum=atoi(classFull);
	return currentPupil;
}

int comparer (const void * a, const void * b)
{
	pupil pa=*((pupil*)a);
	pupil pb=*((pupil*)b);
	if(pa.classNum!=pb.classNum)
		return pa.classNum-pb.classNum;
	if(pa.classLetter!=pb.classLetter)
		return pa.classLetter-pb.classLetter;
	return strcmp(pa.surname,pb.surname);	
}

int main()                     
{

	freopen("pupil.in", "rt", stdin);
	//freopen("myPupil.out", "wt", stdout);

	int testCount;
	int pupilCount;
	char classFull[10];
	pupil pupils[1000];
	cin >> testCount;
	for(int i=0;i<testCount;i++)
	{
		cin >> pupilCount;
		for(int j=0;j<pupilCount;j++)
		{
			cin >> pupils[j].surname >> pupils[j].name >> classFull >> pupils[j].birthDate;
			pupils[j]=makeClass(classFull,pupils[j]);
		}
		qsort(pupils,pupilCount,sizeof(pupil),comparer);	
		cout << "Case " << i+1 << ":" << endl;
		for(int j=0;j<pupilCount;j++)
		{
			cout << pupils[j].classNum << pupils[j].classLetter << ' ' <<  pupils[j].surname << ' ' << pupils[j].name << ' ' << pupils[j].birthDate << endl;
		}
	}
	return 0;
}