program game;

{$ASSERTIONS ON}

Uses SysUtils;

Type
  TPoint = Record
                r,c,s: longint;
               End;
const
  MAX_R = 1000;
  MAX_C = 1000;
  dro: array [1..6] of longint = (-1, -1, 0, 1, 1,  0);
  dco: array [1..6] of longint = ( 0,  1, 1, 1, 0, -1);

  dre: array [1..6] of longint = (-1, 0, 1,  1,  0, -1);
  dce: array [1..6] of longint = ( 0, 1, 0, -1, -1, -1);
var
  ti, tn: longint;
  a: array [1..MAX_R, 1..MAX_C] of boolean;
  q: array [1..MAX_R * MAX_C] of TPoint;
  rows, cols: longint;
  srow, scol: longint;
  i,j:longint;
  c:char;
  l,r:longint;
  result:longint;
  p:TPoint;
  cr,cc:longint;

begin
    assign(input, 'game.in');
    reset(input);
    //assign(output, 'game.out');
    //rewrite(output);

    readln(tn);

    for ti := 1 to tn do
    begin
      readln(rows, cols);
      assert((rows >= 1) and (rows <= MAX_R), 'ROWS out of bounds. Test:' + IntToStr(ti));
      assert((cols >= 1) and (cols <= MAX_C), 'COLS out of bounds. Test:' + IntToStr(ti));

      readln(srow, scol);
      assert((srow >= 1) and (srow <= rows), 'SROW out of bounds. Test:' + IntToStr(ti));
      assert((scol >= 1) and (cols <= cols), 'SCOL out of bounds. Test:' + IntToStr(ti));

      for i := 1 to rows do
      begin

        for j := 1 to cols do
        begin
          read(c);
          assert((c = '0') or (c = '1'), 'Wrong char. Test:' + IntToStr(ti));
          if (c = '1') then
            a[i,j] := true
          else
            a[i,j] := false;
        end;
        readln;
      end;

      l := 1;
      r := 1;
      q[1].r:=srow;
      q[1].c:=scol;
      q[i].s:=0;
      assert(a[srow,scol] = true, 'a[srow,scol] = false. Test:' + IntToStr(ti));
      a[srow,scol] := false;
      result := 0;
      while ((l <= r) and (result = 0)) do
      begin
        p := q[l];
        l := l + 1;

        for i := 1 to 6 do
        begin

        cr := p.r;
        cc := p.c;
        if (cr mod 2 = 0) then
        begin
          cr := cr + dro[i];
          cc := cc + dco[i];
        end
        else
        begin
          cr := cr + dre[i];
          cc := cc + dce[i];
        end;

        if ((cr <= 0) or (cc <= 0) or (cr > rows) or (cc > cols)) then
        begin
          result := p.s + 1;
          break;
        end;

        if (a[cr,cc] = true) then
        begin
          r := r + 1;

          q[r].r:=cr;
          q[r].c:=cc;
          q[r].s:=p.s + 1;

          a[cr,cc] := false;
        end;
        end;
      end;
      if (result > 0) then
        writeln(result)
      else
        writeln('No solution');
    end;

    close(input);
    //close(output);
end.




