import java.io.*;
import java.util.Scanner;

public class Bit
{
	public static void main(String[] args) throws Exception
    {
		new Bit().run();
    }
	
	Scanner in;
	PrintWriter out;
	
	void run() throws Exception
	{
		in = new Scanner(new File("bit.in"));
		//out = new PrintWriter(new FileWriter("bit.out"));
		out = new PrintWriter(System.out);
		
		long MAX_N = 1000000000000000000L;
		
		int test = in.nextInt();
		for(int testi = 0; testi < test; testi++)
		{
			long n = in.nextLong();
			if (!(n >= 1 && n <= MAX_N))
				throw new Exception("N out of bounds. Test:" + testi + " value:" + n);
			
			long l = 1;
			long n1 = n;
			while (n1 % 2 == 0)
			{
				l *= 2;
				n1 /= 2;
			}
			
			long h = 1;
			long n2 = n/2;
			while (n2 > 0)
			{
				h *= 2;
				n2 /= 2;
			}
			out.println(l + " " + h);
		}
		out.close();
	}

}
