program change;

{$ASSERTIONS ON}

Uses SysUtils;

const
  M = 1000000009;
  MAX_N = 100000;

var
    ti, tn: longint;
    a: array[1..MAX_N] of int64;
    i, n : longint;
begin
  assign(input, 'change.in');
  reset(input);
  //assign(output, 'change.out');
  //rewrite(output);

  a[1] := 0;
  a[2] := 1;
  for i := 3 to MAX_N do
      a[i] := ((a[i - 2] + a[i - 1])*(i - 1)) mod M;

  read(tn);

  for ti := 1 to tn do
  begin
    read(n);
    assert((n >= 2) and (n <= MAX_N), 'N out of bounds. Test:' + IntToStr(ti));
    assert((a[n] >= 1) and (a[n] <= 2000000000), 'A[N] out of bounds. Test:' + IntToStr(ti) + ' ' + IntToStr(a[n]));
    writeln(a[n]);
  end;

  close(input);
  //close(output);
end.


