program func;

{$ASSERTIONS ON}

Uses SysUtils, Math;

function f(x,c:extended):extended;
begin
  f := x*x - sqrt(x) + c;
end;

function rbs(l, r, c: extended): extended;
var m, e: extended;
begin
	e := 0.000000001;
	while (r - l > e) do
	begin
          m := (l + r)/2.0;
          if (f(m, c) > 0) then
            r := m
	  else
	    l := m;
	end;
        rbs := l;
end;

function lbs(l, r, c: extended): extended;
var m, e: extended;
begin
        e := 0.000000001;
	while (r - l > e) do
	begin
	  m := (l + r)/2.0;
          if (f(m, c) > 0) then
	    l := m
          else
	    r := m;
        end;
        lbs := r;
end;

var
  ti, tn: integer;
  x0, f0: extended;
  c, r: extended;

begin
    assign(input, 'function.in');
    reset(input);
    //assign(output, 'function.out');
    //rewrite(output);

    readln(tn);
    x0 := Power(0.25, 2.0/3.0);
    f0 := f(x0, 0.0);

    for ti := 1 to tn do
    begin
      readln(c);
      c := -1*c;
      if (c > -f0) then
        writeln('No solution')
      else if ((c >= 0.0) and (c <= -f0)) then
      begin
	writeln(lbs(0.0, x0, c):0:6, ' ', rbs(x0, 1.0, c):0:6);
      end else
      begin
	r := 1.0;
	while (f(r, c) < 0) do
          r := r*2;
	writeln(rbs(1.0, r, c):0:6);
      end;
    end;

    close(input);
    //close(output);
end.

