import java.io.PrintWriter;
import java.util.Random;

public class BitTests {
	public static void main(String[] args) throws Exception
	{
		new BitTests().run();
	}
	
	private void pt(long v)
	{
		if (tests > 0)
		{
			if (v >= 1 && v <= MAX_L)
			{
				tests--;
				out.println(v);
			}
		}
	}
	
	private long p2(int p)
	{
		long v = 1;
		while (p > 0)
		{
			p /= 2;
			v *= 2;
		}
		return v;
	}
	
	long MAX_I = 1000000000L;
	long MAX_L = 1000000000000000000L;
	
	private long nextLong(Random r, long n)
	{
		int mi = 1024*1024*1024;
		int mii = 30; 
		long v;
		if (n <= MAX_I)
		{
			v = r.nextInt((int)n) + 1;
		}
		else
		{
			v = r.nextInt((int)(n/mi));
			v = v << mii;
			v += r.nextInt(mi);
		}
		return v;
	}

	PrintWriter out;
	int tests = 4000;
	private void run() throws Exception {
		out = new PrintWriter("bit.in");
		
		Random r = new Random(25716);
		
		out.println(tests);
		
		pt(26);
		pt(88);
		for (long nn = 10; nn <= MAX_L; nn = nn == MAX_L ? MAX_L + 1: nn*10)
		{
			pt(nn - 1);
			pt(nn);
			if (nn != MAX_L)
				pt(nn + 1);
		}
		
		for (long nn = 2; nn <= MAX_L; nn *= 2)
		{
			pt(nn - 1);
			pt(nn);
			pt(nn + 1);
		}
		
		for (int i = 1; i <= 1025; i++)
		{
			pt(i);
		}
		
		while (tests > 0)
		{
			for (long nn = 10; nn <= MAX_L; nn = nn == MAX_L ? MAX_L + 1: nn*10)
			{
				pt(nextLong(r, nn));
			}
			
			for (int i = 2; i <= 59; i++)
			{
				for (int j = 0; j < i; j++)
				{
					long v = nextLong(r, p2(i - j)) << (i - j);
					pt(v);
				}
			}
		}
	
		out.close();
		
	}
}
